---------------------------------------------------------------
--
-- PteroTools
--
-- by Pan Collette
--
-- Create: 14.05.2003
-- Modified: 06.01.2004
--
-- !!!  PteroLib.mse MUST be incuded FIRST  !!!
--
-- MODIFY THIS AT YOUR OWN RISK 
--
---------------------------------------------------------------

---------------------------------------------------------------
--	Init PteroTools
---------------------------------------------------------------
global _DEBUG_		= false

(
	local _path  = "$scripts\\pteroTools\\"
	local _del	 = #( "$ui\\MacroScripts\\Macro_PteroProps.mcr", _path + "_aboutRollOut.ms")
	local _inc, c


	_inc  = #( _path + "pteroLib.mse" )
	_inc += #( _path + "pteroMat.mse" )
	_inc += #( _path + "pteroProps.mse", _path + "pteroPropsInclude.ms")
	_inc += #( _path + "pteroTools.mse", "$ui\\MacroScripts\\pteroTools.mcr" )

	-- delete old files
	for f in _del do (
		c = ( getfiles f ).count
		if c == 1 do try (
			setFileAttribute f #readOnly false
			deleteFile f
		) catch ()
	)
	try (
		deleteFile (_path + "*.bmp")
	) catch ()

	-- run scripts
	for f in _inc do (
		c = ( getfiles f ).count
		case c of (
			1:			try( fileIn f ) catch (format "Error: PteroTools - executing script: %\n" f)
			default:	format "Error: PteroTools - unable to execute script: %\n" f
		)
	)

)

---------------------------------------------------------------
--	fnDoCallback()
---------------------------------------------------------------
fn fnDoCallback type:#all = try (
	local pos = 1
	local mat, open, col, r, g, b

	-- read Collision materials
	_colMatTable = fnReturnColMats()
	if _colMatTable[2] == undefined do _colMatTable = fnLoadMats()

	if type == #all do (
		-- open PteroProps Panel
		if (open = fnLoadINIexec "DialogOpen" (fnReturnFilename #ini) (fnReturnSection #ini)) == ok do
			open = true
		if open do fnCreatePteroProps()
	)
	updateToolbarButtons()
) catch ()

---------------------------------------------------------------
-- Callbacks definition
---------------------------------------------------------------
callbacks.addScript #postSystemStartup "fnDoCallback()" id:#postStartupPteroToolsInit
